<?php
namespace Geral\Logic\Login;
/**
 * Created by JetBrains PhpStorm.
 * User: paulopimenta
 * Date: 05/03/13
 * Time: 13:05
 * To change this template use File | Settings | File Templates.
 */
use \Geral\Entities\Operador;
use \Geral\Entities\Cliente;
use \Geral\Util\DateUtil;
use \Geral\Entities\Paramgeral;
use \Geral\Entities\Funcionario;
use \Geral\Entities\Equipetrab;

class LoginIntranet extends \Geral\Logic\Login
{
    private $nmoperador;
    private $senha;
    private $operador;
    private $organizacao;
    private $filial;

    public function __construct($nmoperador, $senha)
    {
        $this->nmoperador    = $nmoperador;
        $this->senha         = $senha;
    }

    public function valida(){
        $this->operador = $this->obterOperador($this->nmoperador, $this->senha);
    }

    private function obterOperador($nmoperador, $senha){
        /** @var $operador  \Geral\Entities\Operador */
        $operador           = Operador::findOneByNmacesso($nmoperador);

        if($operador instanceof Operador === false){
            $nmoperador = str_pad($nmoperador, 12, '0', STR_PAD_LEFT);
            if(is_numeric($nmoperador)) {
                $operador = Operador::findOneByCdoperador($nmoperador);
                if($operador instanceof Operador === false){
                    throw new \Geral\Logic\Login\Exceptions\OperadorNaoEncontrado();
                }
            }
            else{
                throw new \Geral\Logic\Login\Exceptions\OperadorNaoEncontrado();
            }
        }
        if (md5($senha) !== $operador->getCdsenhaoperweb()) {
            throw new \Geral\Logic\Login\Exceptions\OperadorSenhaInvalida();
        }

        $this->organizacao  = \Geral\Entities\Organizacao::findOneByNrorg($operador->getNrorg());

        /** @var $cliente  \Geral\Entities\Cliente */
        $cliente    = Cliente::findOneByCdcliente($operador->getCdcliente());

        $data                   = DateUtil::adicionaIntervalo(DateUtil::getDataAtual(), $cliente->getNrdiavalpers());
        $dataValidSomaPer        = $data->format('d-m-Y');
        $dataValidSomaPerYMD     = $data->format('Ymd');

        if($cliente->getDtvalarqpers() != null){
            $dataValidadePer        = $cliente->getDtvalarqpers()->format('d-m-Y');
            $dataValidadePerYMD     = $cliente->getDtvalarqpers()->format('Ymd');
        }
        else{
            $dataValidadePer        = '30/12/1899';
            $dataValidadePerYMD     = '18991230';
        }

        /**@var $paramGeral \Geral\Entities\Paramgeral */
        $paramGeral     = Paramgeral::getObjectByWhere('1 = 1');

        $this->filial   = \Geral\Entities\Filial::findOneByCdfilial($paramGeral->getCdfilial());

        $totDiaVal      = '0';
        if($operador->getDtultatusenh() != null && $paramGeral->getNrdiavalsenh() != null){
            $totDiaVal      = DateUtil::adicionaIntervalo($operador->getDtultatusenh(), $paramGeral->getNrdiavalsenh());
            $totDiaVal      = DateUtil::getQtdeDiasEntre($totDiaVal, DateUtil::getDataAtual());
        }

        $cdmoeda = $cliente->getCdindice() != null ? $cliente->getIndice() : 'real';

        /** @var $funcionario \Geral\Entities\Funcionario */
        $funcionario    = Funcionario::findOneByCdempresaAndCdfunc($operador->getCdempresa(), $operador->getCdfunc());
        /** @var $equipetrab \Geral\Entities\Equipetrab */
        $equipetrab     = Equipetrab::findOneByCdequipetrab($funcionario->getCdequipetrab());

        $grupoAltPonto          = Operador::getRepository()->verificaGrupoAlteraPonto($operador->getCdoperador());

        $result =   $operador->getCdoperador().'@@'.
                    $operador->getNmoperador().'@@'.
                    $operador->getCdcliente().'@@'.
                    $cliente->getNmrazsocclie().'@@'.
                    $cliente->getNrdiavalpers().'@@'.
                    $dataValidSomaPer.'@@'.
                    $dataValidSomaPerYMD.'@@'.
                    $dataValidadePer.'@@'.
                    $dataValidadePerYMD.'@@'.
                    $cliente->getIdlibgerper().'@@'.
                    $operador->getIdopermaster().'@@'.
                    $operador->getIdoperacesso().'@@'.
                    $operador->getCdfunc().'@@'.
                    $totDiaVal.'@@'.
                    $cliente->getNrinsjurclie().'@@'.
                    $cliente->getIdtrabclie().'@@'.
                    'N'.'@@'.
                    $cdmoeda.'@@'.
                    $operador->getIdtpoperador().'@@'.
                    $cliente->getCdativcli().'@@'.
                    $paramGeral->getCdfilial().'@@'.
                    $this->getFilial()->getCdempresa().'@@'.
                    $cliente->getCdclieprincipal().'@@'.
                    $operador->getCdsetor().'@@'.
                    $operador->getSetor()->getNmsetor().'@@'.
                    $equipetrab->getCdequipetrab().'@@'.
                    $equipetrab->getNmequipetrab().'@@'.
                    $equipetrab->getCdoperresp().'@@'.
                    $funcionario->getCdtpadmissao().'@@'.
                    $cliente->getNmbdcliente().'@@'.
                    $grupoAltPonto[0]['GRUPODPAP'];

        tk_set_env_var('SESSAO_ASP', $result);

        return $operador;
    }

    /**
     * Retorna o objeto de operador.
     *
     * @return \Geral\Entities\Operador
     */
    public function getOperador()
    {
        return $this->operador;
    }

    /**
     * Retorna o objeto de filial.
     *
     * @return \Geral\Entities\Filial
     */
    public function getFilial()
    {
        return $this->filial;
    }

    /**
     * Retorna o objeto de organizacao.
     *
     * @return \Geral\Entities\Organizacao
     */
    public function getOrganizacao()
    {
        return $this->organizacao;
    }
    
    /**
     * Envia o email com a nova senha gerada
     */
    public function enviaEmail($entrada,$pesquisa){
        
        if($pesquisa === 'O'){
            $operador     = Operador::findOneByNmacesso($entrada);
        }else{
            $operador     = Operador::findOneByDsemailoper($entrada);
        }
        
        if ($operador instanceof Operador !== false) {
                $email    = $operador->getDsemailoper();
                $nmacesso = $operador->getNmacesso();
                $senha    = rand(100000, 999999);
                $assunto  = 'Recuperação de acesso';
                $mensagem = '<img width = "152" height = "45" dfsrc="https://www.security.teknisa.com/_imagens/logtek.jpg" src="https://www.security.teknisa.com/_imagens/logtek.jpg"/>'
                            .'<br/><br/><strong>RECUPERAÇÃO DE ACESSO</strong><br/>'
                            .'Prezado(a), sua nova senha foi gerada com sucesso!'
                            .'<br/><br/><strong>Usuário:</strong> '.$nmacesso
                            ."<br/><strong>Senha:</strong> ".$senha;
                $senhaBD  = md5($senha);
                $operador->setCdsenhaoperweb($senhaBD);
                $destinatarios = array($email);
                $nomeRemetente = 'Teknisa Software LTDA';
                $remetente     = "sac@teknisa.com";
                
                $db = \Setforms2\Runtime\Connection::getInstance();
                $db->getConn()->beginTransaction();

                try {
                    $envio = \Setforms2\Shared\Notifier::factory();
                    $notification = new \Setforms2\Shared\Business\Notification();
                    
                    $notification->setSubject($assunto);
                    $notification->setFrom($remetente);
                    $notification->setName($nomeRemetente);
                    $notification->setTo($destinatarios);
                    $notification->setBody($mensagem);
                    $envio->setNotificationBusiness($notification);
                                        
                    $envio->send();
                    $connection = \Setforms2\Shared\Registry::getEntityManager();
                    $operador->persist();
                    $connection->flush();
                    $db->getConn()->commit();
                } catch (\Exception $e) {
                    throw $e;
                }
            } else {
                if($pesquisa === 'O'){
                    throw new \Geral\Logic\Login\Exceptions\OperadorNaoEncontrado();
                }
                else{
                    throw new \Geral\Logic\Login\Exceptions\EmailNaoEncontrado();
                }
            }
    }
    
    public function validaNmAcesso($nmacesso){
        $operador     = Operador::findOneByNmacesso($nmacesso);
        if ($operador instanceof Operador === false) {
            return false;
        }
        else{
            return true;
        }
    }
}
