<?php

require_once 'base/FpatipoferiasmEntityBase.php';


/**
 * Enter description here ...
 *
 * @package Entity
 *
 * @author  alessandrobartels
 */
class FpatipoferiasmEntity extends FpaTipoferiasmEntityBase
{


    /**
     * Adiciona itens FpatipoferiasmEntity na lista.
     *
     * @param integer $nrOrgPadrao   Numero da Organizacao Padrao.
     * @param integer $nrOrgTrabalho Numero da Organizacao de Trabalho.
     *
     * @return void
     *
     * @author alessandrobartels -
     *         alessandrobartels - 04/07/2011 - Parametrizado $nrOrgPadrao.
     */
    private function _inicializaLista($nrOrgPadrao, $nrOrgTrabalho){
        $tmp = Fpatipoferiasm::retornaTipoFerias($nrOrgPadrao, $nrOrgTrabalho);
        foreach ($tmp as $tmp_tipo_ferias) {
            $this->addItem($tmp_tipo_ferias, $tmp_tipo_ferias->getNrtipoferias());
        }
    }


    /**
     * Enter description here ...
     *
     * @param integer $nrOrgPadrao   Numero da Organizacao Padrao.
     * @param integer $nrOrgTrabalho Numero da Organizacao de Trabalho.
     * @param integer $nr_tipoferias Numero do Tipo Ferias.
     *
     * @return FpatipoferiasmEntity
     *
     * @author alessandrobartels -
     *         alessandrobartels - 04/07/2011 - Parametrizado $nrOrgPadrao.
     */
    public function retornaTipoFerias($nrOrgPadrao, $nrOrgTrabalho, $nr_tipoferias){
        $itens = $this->getItems();
        if (empty($itens) === true) {
            $this->_inicializaLista($nrOrgPadrao, $nrOrgTrabalho);
            $itens = $this->getItems();
        }

        return $itens[$nr_tipoferias];
    }


    /**
     * Enter description here ...
     *
     * @param FpatipoferiasmEntity $item Item do tipo ferias.
     *
     * @return integer
     *
     * @author alessandrobartels
     */
    public function retornaQtdMesesPeriodoAquisitivo(FpatipoferiasmEntity $item){

        $id_periodo_aquisitivo = $item->historico->getIdperaquisitivo();

        switch ($id_periodo_aquisitivo){
        case FpatipoferiashEntity::IDPERAQUISITIVO_ANO:
            return $item->historico->getQtperaquisitivo() * 12;
        case FpatipoferiashEntity::IDPERAQUISITIVO_MES:
            return $item->historico->getQtperaquisitivo();
        case FpatipoferiashEntity::IDPERAQUISITIVO_DIA:
            return $item->historico->getQtperaquisitivo() / 30;
            /* @todo rever mensagem */
        default:
            //@todo MsgCalculo
            MsgCalculo::getInstance()->adicionaMensagem('Período aquisitivo não definido.');
            //echo 'Periodo aquisitivo nao definido.';
            return;
        }

    }


    /**
     * Enter description here ...
     *
     * @param integer $nrtipoferias Nr Tipo Ferias.
     * @param integer $nrorgTrab    Nr Org.
     *
     * @return boolean
     *
     * @author luistavares 11/08/2011
     */
    public function novoMestre($nrtipoferias, $nrorgTrab){
        try{
            $now = new TkDateTime();
            $now = $now->toString(TkDateTime::FORMAT_DATE);

            $this->setNrtipoferias($nrtipoferias);
            $this->setDtinivigencia($now);
            $this->setNrorg($nrorgTrab);
            $this->setDtinclusao($now);

            $this->persist();

            return true;
        }
        catch (Exception $e){
            return false;
        }

    }


    /**
     * Enter description here ...
     *
     * @param integer $nrtipoferias Nr Tipo Ferias.
     * @param integer $nrorgTrab    Nr Org.
     *
     * @return boolean
     *
     * @author luistavares 11/08/2011
     */
    public function destroiMestre($nrtipoferias, $nrorgTrab){
        try{
            $tipoferias = Fpatipoferiasm::retornaTipoFeriasPelaChave($nrtipoferias, $nrorgTrab);
            if (is_object($tipoferias) === true) {
                /* Adiciona um item à lista, após isso, o item é removido da lista
                 * e enviado para lista de itens removidos, lista essa que irá apagar
                 * todos seus itens quando executar o persist(). */
                $this->addItem($tipoferias, $nrtipoferias);
                $this->removeItem($tipoferias);
                $this->persist();

                return true;
            } else {
                return false;
            }
        }
        catch (Exception $e){
            tk_warning($e->getMessage());
            return false;
        }

    }


}

